//+------------------------------------------------------------------+
//|                                       Fractal dimesion index.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Alex Matulich version                                            |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//
//
//
//
//

extern int FDILength=30;
extern int FDIPrice =PRICE_CLOSE;

//
//
//
//
//

double FDIBuffer[];
double PriceBuffer[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,FDIBuffer);   SetIndexDrawBegin(0,FDILength);
   SetIndexBuffer(1,PriceBuffer);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   double dx2  = MathPow(1.0/FDILength,2);
   int    counted_bars=IndicatorCounted();
   int    i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //
            
   for (i=limit;i>=0;i--)
   {
      PriceBuffer[i] = iMA(NULL,0,1,0,MODE_SMA,FDIPrice,i);
      
      //
      //
      //
      //
      //
     
      double priceMax = PriceBuffer[ArrayMaximum(PriceBuffer,FDILength,i)];
      double priceMin = PriceBuffer[ArrayMinimum(PriceBuffer,FDILength,i)];
      double length   = 0.00;

         if (priceMax == priceMin) length = 1;
         else         
            {
               double pdi = priceMax-priceMin;
         
               //
               //
               //
               //
               //
         
               for (int k = 1; k<=FDILength; k++)
               {
                  double dy = (PriceBuffer[i+k]-PriceBuffer[i+k-1])/pdi;
//                double dy = (PriceBuffer[i+k]-priceMin)/pdi;
                        length += MathSqrt(dx2+dy*dy);
               }
            }
         FDIBuffer[i] = 1 + (MathLog(length)+MathLog(2))/MathLog(2*FDILength);
   }         
   return(0);
}