#property copyright "Fractal Filtered Level (c) HotFx 2012.01.17"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru
#property indicator_chart_window

extern double dist = 0.00003; extern int beg = 1, cnt = 200;
extern color cu = Brown, cl = SteelBlue; extern bool clear = TRUE;
double tmp; datetime bt = 0;

void start()
 {
  if (bt == Time[1]) return;

  bt = Time[1]; ObjectsDeleteAll();
  
  ObjectCreate("beg" + Time[beg], OBJ_VLINE, 0, Time[beg], 0); ObjectSet("beg" + Time[beg], OBJPROP_COLOR, White);
  ObjectCreate("end" + Time[beg + cnt], OBJ_VLINE, 0, Time[beg + cnt], 0); ObjectSet("end" + Time[beg + cnt], OBJPROP_COLOR, White);
  
  for (int i = beg; i <= beg + cnt; i ++)
   {
    double upf = iFractals(NULL, 0, MODE_UPPER, i); double lof = iFractals(NULL, 0, MODE_LOWER, i);
    if (upf != 0 || lof != 0) for (int j = beg; j <= beg + cnt; j ++)
     {
      tmp = iFractals(NULL, 0, MODE_UPPER, j); if (tmp != 0) { TestLine("up", upf, cu); TestLine("up", lof, cu); }
      tmp = iFractals(NULL, 0, MODE_LOWER, j); if (tmp != 0) { TestLine("lo", upf, cl); TestLine("lo", lof, cl); }
     } 
   }  //for (int i = beg;
 } //start

void deinit() { if (clear) ObjectsDeleteAll(); }

void TestLine(string name, double val, int col)
 {
  if (val != 0 && tmp != val && MathAbs(tmp - val) <= dist)
   { ObjectCreate(name + tmp, OBJ_HLINE, 0, 0, tmp); ObjectSet(name + tmp, OBJPROP_COLOR, col); }
 }

