//+------------------------------------------------------------------+
//|                                                Geo_Fractal3.mq4  |
//|                                         Copyright  2011, Geokom |
//|                                             geokom2004@yandex.ru |
//+------------------------------------------------------------------+
//                      
//                      
// Geo_Fractal3.mq4 -          
// 28022012 Geo_Fractal3.mq4 -           
// Alert by Mobidik

#property copyright "Copyright  2011, Geokom"
#property link      "geokom2004@yandex.ru"
#property indicator_chart_window
#define PREFIX "FrL"

extern bool   Only_Current_TF = true;
extern   int  FR_TF1          = PERIOD_D1;
extern   int  FR_TF2          = PERIOD_H4;
extern   int  FR_TF3          = PERIOD_H1;
extern   int  FR_TF4          = PERIOD_M15;
extern color  FR_Up_clr       = clrRed;
extern color  FR_Dn_clr       = clrBlue; 
extern   bool UseShift        = false;

extern bool   AlertsOn        = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern int    SignalBar       = 0;

   bool    ReDraw =  true ;
   
       double FrLowD1=0;
       double FrUpD1=0;
       double FrLowH4=0;
       double FrUpH4=0;
       double FrLowH1=0;
       double FrUpH1=0;
       double FrLowM15=0;
       double FrUpM15=0;

double C,O,H,L, SPR ;
string CommentString;
int k;
   static datetime prevTime_TF1;
   static datetime prevTime_TF2;
   static datetime prevTime_TF3;
   static datetime prevTime_TF4;
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------
void DrawLine (string LineName, bool magnet , datetime Time1,double Price1, datetime Time2,double Price2, bool draw, color LineColor, int LineStyle, bool TrendLine, bool Ray)   //   .     .    -  .
   {
      if (ObjectFind(LineName)==0)
      {
         if(!draw)  {ObjectDelete(LineName);return;}
         
         if (magnet && ObjectGet(LineName,OBJPROP_TIME1) != Time1) 
         {
         ObjectSet(LineName,OBJPROP_TIME1,Time1);
         }
         if (magnet && ObjectGet(LineName,OBJPROP_PRICE1) != Price1) 
         {
         ObjectSet(LineName,OBJPROP_PRICE1,Price1);
         }
         
         if (TrendLine)
         {         
         
            if (magnet && ObjectGet(LineName,OBJPROP_TIME2) != Time2) 
            {
            ObjectSet(LineName,OBJPROP_TIME2,Time2);
            }
            if (magnet && ObjectGet(LineName,OBJPROP_PRICE2) != Price2) 
            {
            ObjectSet(LineName,OBJPROP_PRICE2,Price2);
            }
         }         
       ObjectSet(LineName,OBJPROP_COLOR,LineColor);
       ObjectSet(LineName,OBJPROP_STYLE,LineStyle);
       ObjectSet(LineName,OBJPROP_RAY,Ray);

      }
      
      if (ObjectFind(LineName)!=0&&draw)
      {
         if (!TrendLine)
         {
           ObjectCreate (LineName,OBJ_HLINE,0,0,Price1,0);
         }

         if (TrendLine)
         {       
           ObjectCreate (LineName,OBJ_TREND,0,Time1,Price1,Time2,Price2);
           ObjectSet(LineName,OBJPROP_RAY,Ray);
         }
      
      ObjectSet(LineName,OBJPROP_COLOR,LineColor);
      ObjectSet(LineName,OBJPROP_STYLE,LineStyle);
      }
return;
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   for (int i = ObjectsTotal()-1; i >= 0; i--)   
   if (StringSubstr(ObjectName(i), 0, 
       StringLen(PREFIX)) == PREFIX)
       ObjectDelete(ObjectName(i));
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
int limit;
int counted_bars=IndicatorCounted();
//    -   ,   
if(counted_bars<0) return(-1);
//  
if(counted_bars>0) counted_bars--;
limit=Bars-counted_bars;

     if ( SPR ==0)    { SPR  = MarketInfo(Symbol(),MODE_SPREAD);}
     
     if (Digits ==2 || Digits ==4) {k = 10;}
     if (Digits ==3 || Digits ==5) {k = 1;}

     double LowShift =  0;
     double HighShift = 0;
     
     if (UseShift){ 
     LowShift = 10 *Point / k;
     HighShift = SPR*Point + 10*Point / k;
     } 
//=============================================================================================
 if(Only_Current_TF) FR_TF1=0;
//    D1 =======================================================================
        FrLowD1=0;
        FrUpD1=0;

       for (int f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowD1==0)&&(iFractals(NULL, FR_TF1, MODE_LOWER,f)!=0))
       {FrLowD1=iFractals(NULL, FR_TF1, MODE_LOWER,f);int fld1=f;
       DrawLine(PREFIX+"FrLowD1",ReDraw,iTime(NULL,FR_TF1,fld1),FrLowD1-LowShift,2*TimeCurrent() - iTime(NULL, 0,10),FrLowD1-LowShift,true,FR_Up_clr,4,true,false );} //    
       
       if ((FrUpD1==0)&&(iFractals(NULL, FR_TF1, MODE_UPPER,f)!=0)) 
       {FrUpD1=iFractals(NULL, FR_TF1, MODE_UPPER,f);int fud1=f;
       DrawLine(PREFIX+"FrUpD1",ReDraw,iTime(NULL,FR_TF1,fud1),FrUpD1+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpD1+HighShift,true,FR_Dn_clr,4,true,false );} //    
       
       }
       
       for (int i=1;i<fld1;i++) //  
       {
         if (FrLowD1!=0)
         {
            ObjectDelete (PREFIX+"D1S");
            
            if (iClose(NULL, FR_TF1,i) < FrLowD1)
            {
 //            ObjectCreate("D1S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF1,fld1) ,FrLowD1,0,0 );
             ObjectCreate(PREFIX+"D1S", OBJ_TEXT,  0,2*TimeCurrent() - iTime(NULL, 0,10) ,FrLowD1,0,0 );
             ObjectSetText(PREFIX+"D1S", "TF "+FR_TF1, 10,"arial",FR_Up_clr);
            
             DrawLine(PREFIX+"FrLowD1",ReDraw,iTime(NULL,FR_TF1,fld1),FrLowD1-LowShift,2*TimeCurrent() - iTime(NULL,0,10),FrLowD1-LowShift,true,FR_Up_clr,0,true,false ); 
             break;
            }
         }
       }
       for ( i=1;i<fud1;i++) //  
       {
      
         if (FrUpD1!=0)
         {
            ObjectDelete (PREFIX+"D1B");
         
            if (iClose(NULL, FR_TF1,i) > FrUpD1)
            {
//             ObjectCreate("D1B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF1,fud1) ,FrUpD1,0,0 );
             ObjectCreate(PREFIX+"D1B", OBJ_TEXT,0, 2*TimeCurrent() - iTime(NULL, 0,10)  ,FrUpD1,0,0 );
             ObjectSetText(PREFIX+"D1B", "TF "+FR_TF1, 10,"arial", FR_Dn_clr);
            
             DrawLine(PREFIX+"FrUpD1",ReDraw,iTime(NULL,FR_TF1,fud1),FrUpD1+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpD1+HighShift,true,FR_Dn_clr,0,true,false); 
             break;
            }
         }
      
        } 
      

//   D1 ============================================================================
//=============================================================================================
 if(!Only_Current_TF) 
 {
//=============================================================================================
//    H4 =======================================================================
        FrLowH4=0;
        FrUpH4=0;

       for ( f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowH4==0)&&(iFractals(NULL, FR_TF2, MODE_LOWER,f)!=0))
       {FrLowH4=iFractals(NULL, FR_TF2, MODE_LOWER,f);int flh4=f;
       DrawLine(PREFIX+"FrLowH4",ReDraw,iTime(NULL,FR_TF2,flh4),FrLowH4-LowShift,2*TimeCurrent() - iTime(NULL,0,10),FrLowH4-LowShift,true,FR_Up_clr,4,true,false);} //    
       
       if ((FrUpH4==0)&&(iFractals(NULL, FR_TF2, MODE_UPPER,f)!=0)) 
       {FrUpH4=iFractals(NULL, FR_TF2, MODE_UPPER,f);int fuh4=f;
       DrawLine(PREFIX+"FrUpH4",ReDraw,iTime(NULL,FR_TF2,fuh4),FrUpH4+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpH4+HighShift,true,FR_Dn_clr,4,true,false);} //    
       
       }
       
       for ( i=1;i<flh4;i++) //  
       {
         if (FrLowH4!=0)
         {
            ObjectDelete (PREFIX+"H4S");
            if (iClose(NULL, FR_TF2,i) < FrLowH4)
            {
//           ObjectCreate("H4S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF2,flh4) ,FrLowH4,0,0 );
             ObjectCreate(PREFIX+"H4S", OBJ_TEXT,0, 2*TimeCurrent() - iTime(NULL, 0,10)  ,FrLowH4,0,0 );
             ObjectSetText(PREFIX+"H4S", "TF "+FR_TF2, 9,"arial",FR_Up_clr);
            
             DrawLine(PREFIX+"FrLowH4",ReDraw,iTime(NULL,FR_TF2,flh4),FrLowH4-LowShift,2*TimeCurrent() - iTime(NULL,0,10),FrLowH4-LowShift,true,FR_Up_clr,0,true, false); 
             break;
            }
         }
       }
       for ( i=1;i<fuh4;i++) //  
       {
      
         if (FrUpH4!=0)
         {
            ObjectDelete (PREFIX+"H4B");         
            if (iClose(NULL, FR_TF2,i) > FrUpH4 )
            {
//             ObjectCreate("H4B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF2,fuh4) ,FrUpH4,0,0 );
             ObjectCreate(PREFIX+"H4B", OBJ_TEXT,0,  2*TimeCurrent() - iTime(NULL, 0,10)  ,FrUpH4,0,0 );
             ObjectSetText(PREFIX+"H4B", "TF "+FR_TF2, 9,"arial", FR_Dn_clr);
            
             DrawLine(PREFIX+"FrUpH4",ReDraw,iTime(NULL,FR_TF2,fuh4),FrUpH4+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpH4+HighShift,true,FR_Dn_clr,0,true,false); 
             break;
            }
         }
      
        } 
      

//   H4 ============================================================================
//=============================================================================================
//    H1 =======================================================================
        FrLowH1=0;
        FrUpH1=0;

       for ( f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowH1==0)&&(iFractals(NULL, FR_TF3, MODE_LOWER,f)!=0))
       {FrLowH1=iFractals(NULL, FR_TF3, MODE_LOWER,f);int flh1=f;
       DrawLine(PREFIX+"FrLowH1",ReDraw,iTime(NULL,FR_TF3,flh1),FrLowH1-LowShift,2*TimeCurrent() - iTime(NULL,0,10),FrLowH1-LowShift,true,FR_Up_clr,4,true,false);} //    
       
       if ((FrUpH1==0)&&(iFractals(NULL, FR_TF3, MODE_UPPER,f)!=0)) 
       {FrUpH1=iFractals(NULL, FR_TF3, MODE_UPPER,f);int fuh1=f;
       DrawLine(PREFIX+"FrUpH1",ReDraw,iTime(NULL,FR_TF3,fuh1),FrUpH1+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpH1+HighShift,true,FR_Dn_clr,4,true,false);} //    
       
       }
       
       for ( i=1;i<flh1;i++) //  
       {
         if (FrLowH1!=0)
         {
            ObjectDelete ("H1S");
            if (iClose(NULL, FR_TF3,i) < FrLowH1)
            {
//             ObjectCreate("H1S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF3,flh1) ,FrLowH1,0,0 );
             ObjectCreate(PREFIX+"H1S", OBJ_TEXT,0,2*TimeCurrent() - iTime(NULL, 0,10) ,FrLowH1,0,0 );
             ObjectSetText(PREFIX+"H1S", "TF "+FR_TF3, 8,"arial",FR_Up_clr);
             DrawLine(PREFIX+"FrLowH1",ReDraw,iTime(NULL,FR_TF3,flh1),FrLowH1-LowShift,2*TimeCurrent() - iTime(NULL,0,10), FrLowH1-LowShift,true, FR_Up_clr,0,true,false); 
             break;
            }
         }
       }
       for ( i=1;i<fuh1;i++) //  
       {
      
         if (FrUpH1!=0)
         {
            ObjectDelete (PREFIX+"H1B");         
         
            if (iClose(NULL, FR_TF3,i) > FrUpH1)
            {
//             ObjectCreate("H1B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF3,fuh1) ,FrUpH1,0,0 );
             ObjectCreate(PREFIX+"H1B", OBJ_TEXT, 0, 2*TimeCurrent() - iTime(NULL, 0,10)  ,FrUpH1,0,0 );
             ObjectSetText(PREFIX+"H1B", "TF "+FR_TF3, 8,"arial", FR_Dn_clr);
             DrawLine(PREFIX+"FrUpH1",ReDraw,iTime(NULL,FR_TF3,fuh1),FrUpH1+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpH1+HighShift,true,FR_Dn_clr,0,true,false ); 
             break;
            
            }
         }
      
        } 
      

//   H1 ==========================================================================
//=============================================================================================
//    M15 ======================================================================
        FrLowM15=0;
        FrUpM15=0;

       for ( f=1;f<50;f++) //  ( f=1 -  1   )
       {
       if ((FrLowM15==0)&&(iFractals(NULL, FR_TF4, MODE_LOWER,f)!=0))
       {FrLowM15=iFractals(NULL, FR_TF4, MODE_LOWER,f);int flm15=f;
       DrawLine(PREFIX+"FrLowM15",ReDraw,iTime(NULL,FR_TF4,flm15),FrLowM15-LowShift,2*TimeCurrent() - iTime(NULL,0,10), FrLowM15-LowShift,true,FR_Up_clr,4,true, false);} //    
       
       if ((FrUpM15==0)&&(iFractals(NULL, FR_TF4, MODE_UPPER,f)!=0)) 
       {FrUpM15=iFractals(NULL, FR_TF4, MODE_UPPER,f);int fum15=f;
       DrawLine(PREFIX+"FrUpM15",ReDraw,iTime(NULL,FR_TF4,fum15),FrUpM15+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpM15+HighShift,true,FR_Dn_clr,4,true,false);} //    
       
       }
       
       for ( i=1;i<flm15;i++) //  
       {
         if (FrLowM15!=0)
         {
            ObjectDelete (PREFIX+"M15S");
            if (iClose(NULL, FR_TF4,i) < FrLowM15)
            {
//             ObjectCreate("M15S", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF4,flm15) ,FrLowM15,0,0 );
             ObjectCreate(PREFIX+"M15S", OBJ_TEXT, 0, 2*TimeCurrent() - iTime(NULL, 0,10) ,FrLowM15,0,0 );
             ObjectSetText(PREFIX+"M15S", "TF "+FR_TF4, 8,"arial",FR_Up_clr);
             DrawLine(PREFIX+"FrLowM15",ReDraw,iTime(NULL,FR_TF4,flm15),FrLowM15-LowShift,2*TimeCurrent() - iTime(NULL,0,10),FrLowM15-LowShift,true,FR_Up_clr,0,true,false); 
             break;
            }
         }
       }
       for ( i=1;i<fum15;i++) //  
       {
      
         if (FrUpM15!=0)
         {
            ObjectDelete (PREFIX+"M15B");         
         
            if (iClose(NULL, FR_TF4,i) > FrUpM15)
            {
//             ObjectCreate("M15B", OBJ_TEXT, 0,2*TimeCurrent() - iTime(NULL, FR_TF4,fum15) ,FrUpM15,0,0 );
             ObjectCreate(PREFIX+"M15B", OBJ_TEXT,0, 2*TimeCurrent() - iTime(NULL, 0,10) ,FrUpM15,0,0 );
             ObjectSetText(PREFIX+"M15B", "TF "+FR_TF4, 8,"arial", FR_Dn_clr);
             DrawLine(PREFIX+"FrUpM15",ReDraw,iTime(NULL,FR_TF4,fum15),FrUpM15+HighShift,2*TimeCurrent() - iTime(NULL,0,10),FrUpM15+HighShift,true,FR_Dn_clr,0,true,false); 
             break;
            
            }
         }
      
        } 
//   M15 =========================================================================
}
//=============================================================================================
if(AlertsOn)
 {
//--------------------------------------------------------------------------------------------- 
   if(prevTime_TF1 != Time[0])
   {
    if (Close[0+SignalBar] < FrLowD1 && Close[1+SignalBar] > FrLowD1)
    {
     manageAlerts("FrLow TF "+"("+FR_TF1+")");
     prevTime_TF1 = Time[0];
    }
//---------------------------------------------------------------------------------------------        
    if (Close[0+SignalBar] > FrUpD1  && Close[1+SignalBar] < FrUpD1) 
    {
     manageAlerts("FrUp TF "+"("+FR_TF1+")");
     prevTime_TF1 = Time[0];
    }
   }    
//==============================================================================================
   if(prevTime_TF2 != Time[0])
   {     
    if (Close[0+SignalBar] < FrLowH4 && Close[1+SignalBar] > FrLowH4) 
    {
     manageAlerts("FrLow TF "+"("+FR_TF2+")");
     prevTime_TF2 = Time[0];
    }
   }    
//---------------------------------------------------------------------------------------------    
   if(prevTime_TF2 != Time[0])
   {     
    if (Close[0+SignalBar] > FrUpH4  && Close[1+SignalBar] < FrUpH4)  
    {
     manageAlerts("FrUp TF "+"("+FR_TF2+")");
     prevTime_TF2 = Time[0];
    }
   }    
//==============================================================================================    
   if(prevTime_TF3 != Time[0])
   {      
    if (Close[0+SignalBar] < FrLowH1 && Close[1+SignalBar] > FrLowH1)
    {
     manageAlerts("FrLow TF "+"("+FR_TF3+")");
     prevTime_TF3 = Time[0];
    }
//---------------------------------------------------------------------------------------------
    if (Close[0+SignalBar] > FrUpH1  && Close[1+SignalBar] < FrUpH1)
    {
     manageAlerts("FrUp TF "+"("+FR_TF3+")");
     prevTime_TF3 = Time[0];
    }
   }     
//============================================================================================== 
   if(prevTime_TF4 != Time[0])
   {    
    if (Close[0+SignalBar] < FrLowM15 && Close[1+SignalBar] > FrLowM15)
    {
     manageAlerts("FrLow TF "+"("+FR_TF4+")");
     prevTime_TF4 = Time[0];
    } 
//---------------------------------------------------------------------------------------------
    if (Close[0+SignalBar] > FrUpM15 && Close[1+SignalBar] < FrUpM15) 
    {
     manageAlerts("FrUp TF "+"("+FR_TF4+")");
     prevTime_TF4 = Time[0];
    } 
   }
//---------------------------------------------------------------------------------------------
 }  
   return(0);
}
//---------------------------------------------------------------------------------------------
void manageAlerts(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) 
      {
          previousAlert  = doWhat;
          previousTime   = Time[0];
          message =  StringConcatenate(Symbol()," - ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ","   ",doWhat);
             
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Geo_Fractal4"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      } 
}
//---------------------------------------------------------------------------------------------