//+------------------------------------------------------------------+
//|                                         BasketStrengthGroups.mq4 |
//|                                        Copyright  2007, sjcoinc |
//|                                            sjcoinc2000@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, sjcoinc"
#property link      "sjcoinc2000@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2 


extern color   FractalColorUp = Magenta;
extern color   FractalColorDn = DeepSkyBlue;
extern int     FractalLookback = 3;

extern double  Offset = 10;


double upper[], lower[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

      
      SetIndexBuffer(0,upper);
      SetIndexStyle(0,DRAW_ARROW,0,0, FractalColorUp);
      SetIndexArrow(0,217);
      SetIndexLabel(0,"Upper");
      
      SetIndexBuffer(1,lower);
      SetIndexStyle(1,DRAW_ARROW,0,0,FractalColorDn);
      SetIndexArrow(1,218);
      SetIndexLabel(1,"Lower");
//----
   return(0);
  }
//+----------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment(" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double up=0,down=0;

   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(int i=0; i<limit; i++)   
      {
       up = iFractals(Symbol(),0,MODE_UPPER,i+FractalLookback);
       down = iFractals(Symbol(),0,MODE_LOWER,i+FractalLookback);
       
       if ( up != 0 )      upper[i+FractalLookback] = up   + Offset*Point;
       if ( down != 0 )    lower[i+FractalLookback] = down - Offset*Point;
        
      }
        
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+