
#property copyright " 2007 RickD"
#property link      "www.e2e-fx.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern int Fr.Period = 6;
extern int MaxBars = 500;
double g_ibuf_84[];
double g_ibuf_88[];
;
void init() {
   SetIndexBuffer(0, g_ibuf_84);
   SetIndexBuffer(1, g_ibuf_88);
   SetIndexEmptyValue(0, 0);
   SetIndexEmptyValue(1, 0);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 234);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 233);
}

void start() {
   int li_4;
   double ld_8;
   int li_0 = IndicatorCounted();
   if (li_0 >= 0) {
      if (li_0 > 0) li_0--;
      li_4 = MathMin(Bars - li_0, MaxBars);
      ld_8 = 0;
      for (int li_16 = 1; li_16 <= 20; li_16++) ld_8 += 0.3 * (High[li_16] - Low[li_16]) / 20.0;
      for (li_16 = Fr.Period + 0; li_16 <= li_4 + Fr.Period; li_16++) {
         g_ibuf_84[li_16] = 0;
         g_ibuf_88[li_16] = 0;
         if (is_upper_fr(li_16, Fr.Period)) g_ibuf_84[li_16] = High[li_16] + ld_8;
         if (is_lower_fr(li_16, Fr.Period)) g_ibuf_88[li_16] = Low[li_16] - ld_8;
      }
   }
}

bool is_upper_fr(int ai_0, int ai_4) {
   for (int li_8 = 1; li_8 <= ai_4; li_8++) {
      if (ai_0 + li_8 >= Bars || ai_0 - li_8 < 0) return (FALSE);
      if (High[ai_0] < High[ai_0 + li_8]) return (FALSE);
      if (High[ai_0] < High[ai_0 - li_8]) return (FALSE);
   }
   return (TRUE);
}

bool is_lower_fr(int ai_0, int ai_4) {
   for (int li_8 = 1; li_8 <= ai_4; li_8++) {
      if (ai_0 + li_8 >= Bars || ai_0 - li_8 < 0) return (FALSE);
      if (Low[ai_0] > Low[ai_0 + li_8]) return (FALSE);
      if (Low[ai_0] > Low[ai_0 - li_8]) return (FALSE);
   }
   return (TRUE);
}
