//+--------------------------------------------------------------------------------------------+
//|   Fractal_SR.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Crimson

extern int Width = 1;
extern int shift = 0;

int Trend;
double MyPoint,ev=EMPTY_VALUE;

double Res[];
double Sup[];

int init()
{
   IndicatorBuffers(2);

   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,Width);
   SetIndexBuffer(0,Res);
   
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,Width);
   SetIndexBuffer(1,Sup);
   
   SetIndexShift(0,shift);
   SetIndexShift(1,shift);
   
   MyPoint = Point;
	if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1))
	{
      MyPoint = Point*10;
	}
	if (Digits == 6 || (Digits == 4 && StringFind(Symbol(), "JPY") != -1))
	{
      MyPoint = Point*100;
	}

   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   int limit = Bars-counted_bars;
   
   for (int i=limit;i>=0;i--)
   {
      Res[i] = Res[i+1];
      Sup[i] = Sup[i+1];
      
      if (iFractals(NULL,0,MODE_UPPER,i+2) > 0)
      {
         Res[i+2] = NormalizeDouble(High[i+2],4);
         Res[i+1] = NormalizeDouble(High[i+2],4);
         Res[i] = NormalizeDouble(High[i+2],4);
      }

      if (iFractals(NULL,0,MODE_LOWER,i+2) > 0)
      {
         Sup[i+2] = NormalizeDouble(Low[i+2],4);
         Sup[i+1] = NormalizeDouble(Low[i+2],4);
         Sup[i] = NormalizeDouble(Low[i+2],4);
      }
      
      if (Res[i+1] < ev && NormalizeDouble(High[i],4) > NormalizeDouble(Res[i+1],4))
      {
         Res[i] = ev;
      }             

      if (Sup[i+1] < ev && NormalizeDouble(Low[i],4) < NormalizeDouble(Sup[i+1],4))
      {
         Sup[i] = ev;
      }             
   }
}

