//+------------------------------------------------------------------+
//|                                 Polarized Fractal Efficiency.mq4 |
//|                               Hans Hanulla, prorgammed by Malcik |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Hans Hanulla, prorgammed by Malcik"
#property link      ""

#property indicator_separate_window
//#property indicator_minimum -100
//#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 Red
//---- input parameters
extern int       Per=10;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int    i=Bars-counted_bars-1;
   int    sum,j;
//----
   for(int shift=i;shift>=0;shift--)
     {
        ExtMapBuffer1[shift]=MathSqrt(((Close[shift]-Close[shift+1])/Point)*((Close[shift]-Close[shift+1])/Point)+1);
        if(Close[shift]>Close[shift+Per])
          {
           ExtMapBuffer2[shift]=100*MathSqrt((((Close[shift]-Close[shift+Per])/Point)*((Close[shift]-Close[shift+Per])/Point))+(Per*Per))/(ExtMapBuffer1[shift]+ExtMapBuffer1[shift+1]+ExtMapBuffer1[shift+2]+ExtMapBuffer1[shift+3]+ExtMapBuffer1[shift+4]+ExtMapBuffer1[shift+5]+ExtMapBuffer1[shift+6]+ExtMapBuffer1[shift+7]+ExtMapBuffer1[shift+8]+ExtMapBuffer1[shift+9]+ExtMapBuffer1[shift+10]);
          }
        else
          {
           ExtMapBuffer2[shift]=(-100)*MathSqrt((((Close[shift]-Close[shift+Per])/Point)*((Close[shift]-Close[shift+Per])/Point))+(Per*Per))/(ExtMapBuffer1[shift]+ExtMapBuffer1[shift+1]+ExtMapBuffer1[shift+2]+ExtMapBuffer1[shift+3]+ExtMapBuffer1[shift+4]+ExtMapBuffer1[shift+5]+ExtMapBuffer1[shift+6]+ExtMapBuffer1[shift+7]+ExtMapBuffer1[shift+8]+ExtMapBuffer1[shift+9]+ExtMapBuffer1[shift+10]);
          }
     }
   for(shift=i;shift>=0;shift--)
     {
      ExtMapBuffer1[shift]=iMAOnArray(ExtMapBuffer2,0,5,0,MODE_EMA,shift);
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+